/***************************************************************************
* This is a program which will receive data from the Hydra and then
* transmit some data to the Hydra as a TCP Client.
*
* We assume that the Hydra lives at port 120 and IP address 192.168.1.100.
*
* We need to give credit where it is due. I quickly grabbed a bunch of
* this code from the internet at:
* http://www.geocities.com/siliconvalley/2072/sockprog.htm
*
* Compiled using LCC version 3.8.
* You can find LCC at http://www.cs.virginia.edu/~lcc-win32/
*
* Written by: Shane Avery
*****************************************************************************/
#include <stdio.h>
#include <winsock.h>

int main()
{
	WSADATA ws;
	WSAStartup(0x0202,&ws);

	SOCKET tcp_socket;
	struct sockaddr_in peer;
	int peerlen;

	char recvbuffer[64];
	int size;

	// Declare port we are connecting to.
	peer.sin_family = AF_INET;
	peer.sin_port = htons(120);
	peer.sin_addr.s_addr = inet_addr("192.168.1.100");

	// Define the TCP socket. SOCK_STREAM for TCP.
	tcp_socket = socket(AF_INET, SOCK_STREAM, 0);

	// Connect to the Hydra which is now acting as the TCP server.
	puts("Connecting to Hydra.");
	connect(tcp_socket, (struct sockaddr*)&peer, sizeof(peer));
	puts("Connected");

	// Send some data to the Hydra.
	puts("Sending data to the Hydra.");
	send(tcp_socket, "Hello from PC.\r", 15, 0);

	// Receive data from the Hydra and display it.
	size = recv(tcp_socket, recvbuffer, sizeof(recvbuffer),0);
	printf("Received %i bytes from Hydra.\n", size);
	printf("Received data is: %s\n", recvbuffer);

	closesocket(tcp_socket);

	return 0;
}
