/***************************************************************************
* This is a program which will receive data from the Hydra and then
* transmit some data to the Hydra using UDP.
*
* We assume that the Hydra lives at port 120.
*
* We need to give credit where it is due. I quickly grabbed a bunch of
* this code from the internet at:
* http://www.geocities.com/siliconvalley/2072/sockprog.htm
*
* Compiled using LCC version 3.8.
* You can find LCC at http://www.cs.virginia.edu/~lcc-win32/
*
* Written by: Shane Avery
*****************************************************************************/
#include <stdio.h>
#include <winsock.h>


int main()
{
	WSADATA ws;
	WSAStartup(0x0202,&ws);

	SOCKET udp_socket;
	struct sockaddr_in peer;
	int peerlen;

	unsigned char buffer[256];
	int size;

	// Declare port we are connecting to.
	peer.sin_family = AF_INET;
	peer.sin_port = htons(120);
	peer.sin_addr.s_addr = htonl(INADDR_ANY);

	// Define the UDP socket. SOCK_DGRAM for UDP.
	udp_socket = socket(AF_INET, SOCK_DGRAM, 0);

	// Bind the socket
	bind(udp_socket,(struct sockaddr *)&peer,sizeof(peer));

	peerlen=sizeof(peer);

	// Display that we are waiting for data.
	puts("Waiting for data from the Hydra.");

	// Read data from the Hydra.
	size = recvfrom(udp_socket, buffer, sizeof(buffer),0, (struct sockaddr *)&peer, &peerlen);

	// Display how much data we got from the Hydra.
	printf("Received %i bytes from the Hydra.\n", size);

	// Display what the data is.
	printf("Received data is: %s\n", buffer);

	// Send data to the Hydra.
	puts("Sending data to the Hydra.");
	sendto(udp_socket, "Hello from PC.\r", 15, 0, (struct sockaddr *)&peer, sizeof(peer));


	puts("Done");

	return 0;
}


